// Klax.h: Schnittstelle fr die Klasse CKlax.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KLAX_H__8AFD2033_64A5_4BDB_9186_EB055F278F24__INCLUDED_)
#define AFX_KLAX_H__8AFD2033_64A5_4BDB_9186_EB055F278F24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CKlax  
{
public:
	CKlax();
	virtual ~CKlax();
	void spieler_bewegen(bool richtung);
	void spieler_action();
	void spiel_init(int geschw, int fehler, int leben, int farben, bool lifo);
	void spiel_pause();
	void spiel_zeichnen(HDC &hdc);
	void gameloop();
	

private:
	byte status;
	// Spielfunktionen
	void spiel_gameover();
	void spiel_start();
	void spiel_weiter();

	// Punktevergabe
	static const int punkte[8];
	// Farbtabelle
	static const COLORREF farbtabelle[2][8];
	
	// Parameter fr die Spieleigenschaften
	struct Spielparameter
		{
		byte geschw;
		byte fehler;
		byte leben;
		byte farben;
		bool lifo;
	} optionen;
	
	// Der Spieler mit seinen Funktionen und Eigenschaften
	struct Spieler
		{
		byte leben;
		byte level;
		byte fehler;
		int levelziel[8];
		long punkte;
		byte pos;
		byte halter[4];
		void stein_aufnehmen(byte farbe);
		byte stein_abgeben(bool lifo);
		void leveltest(byte quelle);
		void level_init();
	} player;
	void spieler_init();
	void spieler_zeichnen(HDC &hdc);

	// Die zwei Felder und ihre Funktionen
	byte durchlauf[5][12];
	byte auffang[5][5];
	void durchlauf_weiter();
	void auffang_neu(byte pos, byte farbe);
	void auffang_testen(byte multi=1);
	void auffang_nachruecken();
	void durchlauf_zeichnen(HDC &hdc);
	void auffang_zeichnen(HDC &hdc);

	// Spielfeld zeichnen
	void hintergrund_zeichnen(HDC &hdc);
	void texte_zeichnen(HDC &hdc);
	double potenz(int zahl, int potenz);
	HFONT textFont;

	// Stein zeichnen
	void stein_zeichnen(HDC &hdc, int posx, int posy, byte farbe);
	HBRUSH pinsel[7];
	HPEN stifft[7];
};

#endif // !defined(AFX_KLAX_H__8AFD2033_64A5_4BDB_9186_EB055F278F24__INCLUDED_)
