#include <windows.h>
#include "Klax.h"

#define WindowTitle "Klax-Test"
#define WindowClassName "DDWinClass"
#define FENSTERBREITE 400
#define FENSTERHOEHE 500

CKlax game;
bool running;
bool Active = true;		// Fenster aktiv?
HDC hgr;

void CALLBACK gameloop(HWND hwnd, UINT msg, UINT idEvent, DWORD dwTime)
{
	if (Active)
	{
		game.gameloop();
		RECT testrect;
		SetRect(&testrect,30,30,200,300);
		InvalidateRect(hwnd,NULL,TRUE);
	}
}


LONG FAR WINAPI WndProc (HWND, UINT, UINT, LONG);

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg ;
	HWND hwnd ;
	WNDCLASS wndclass ;

	// luft schon eine Instanz des Prog, wenn nein:
	// Fensterklasse mit Daten fllen und Registrieren

	if (!hPrevInstance)
	{
		wndclass.style = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc = WndProc;
		wndclass.cbClsExtra = 0;
		wndclass.cbWndExtra = 0;
		wndclass.hInstance = hInstance;
		wndclass.hIcon = LoadIcon (NULL , IDI_APPLICATION) ;
		wndclass.hCursor = LoadCursor (NULL , IDC_ARROW) ;
		wndclass.hbrBackground = (HBRUSH)GetStockObject (BLACK_BRUSH) ;
		wndclass.lpszMenuName = NULL ;
		wndclass.lpszClassName = WindowClassName ;
		RegisterClass (&wndclass);
	}

	// Fenster erstellen und anzeigen
   hwnd = CreateWindowEx (0,WindowClassName, WindowTitle, WS_POPUPWINDOW|WS_CAPTION|WS_MINIMIZEBOX,
						100,150,FENSTERBREITE,FENSTERHOEHE,NULL, NULL, hInstance, NULL);
   ShowWindow (hwnd, nCmdShow);
   UpdateWindow (hwnd);
   SetFocus(hwnd);

   // Startparameter des Spiels setzen
   game.spiel_init(1,10,5,5,true);
   SetTimer(hwnd,1,250,gameloop);

   SendMessage(hwnd,WM_PAINT,NULL,NULL);

   // Die Fensternarichten von Windows abfangen und verarbeiten
   running = true;
   while(running)
   {
	   if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   {
			if (msg.message == WM_QUIT) break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
	   }
	   else if (Active)
           {
				
           }
           else
           {
                WaitMessage();
           }
   }

   // Aufrumarbeiten
   KillTimer(hwnd,1);
   
   return msg.wParam;
}

// Die Fensterprozedur
LONG FAR WINAPI WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
{
	PAINTSTRUCT ps;
	switch (message)
	{	
	case WM_KEYDOWN:	// Tastatur abfrage
		{
			switch (wParam)
			{
				case VK_ESCAPE:		// Mit ESC das Programm beenden
					running = false;
					return 0;
				// Spieltasten
				case VK_NUMPAD0: game.spiel_pause(); break;
				case VK_LEFT:
					game.spieler_bewegen(false);SendMessage(hwnd,WM_PAINT,NULL,NULL);break;
				case VK_RIGHT:
					game.spieler_bewegen(true);SendMessage(hwnd,WM_PAINT,NULL,NULL);break;
				case VK_SPACE:
				case VK_DOWN:
					game.spieler_action();SendMessage(hwnd,WM_PAINT,NULL,NULL);break;
			} 
			break;
		}

	case WM_DESTROY:	// Schlieen des Fensters
		{
			PostQuitMessage (0);
			return 0;
		} break;
		
	case WM_ACTIVATE: // Pause wenn minimirt
		{
			Active = !((BOOL)HIWORD(wParam));

			return 0;
		} break;

	case WM_PAINT:
		{
			hgr = BeginPaint(hwnd, &ps);
			// HDC hdc = CreateCompatibleDC(hgr);
			// HBITMAP bmp = CreateCompatibleBitmap(hdc,400,500);
			//	game.spiel_zeichnen(bmp);
			//	BitBlt(bmp,0,0,100,100,hgr,0,0,SRCCOPY);
			game.spiel_zeichnen(hgr);
			EndPaint(hwnd, &ps);
		}break;

	//case WM_SETCURSOR:
		//{// Cursor auschallten
            //SetCursor(NULL);
            //return TRUE;
		//} break;
	}
	return DefWindowProc (hwnd, message, wParam, lParam);
}